Package org.codehaus.janino

# Class Java.Lvalue

java.lang.Object
org.codehaus.janino.Java.Located
org.codehaus.janino.Java.Atom
org.codehaus.janino.Java.Rvalue
org.codehaus.janino.Java.Lvalue

All Implemented Interfaces:
  `Java.ArrayInitializerOrRvalue`, `Java.ElementValue`, `Java.Locatable`

Direct Known Subclasses:
  `Java.AmbiguousName`, `Java.ArrayAccessExpression`, `Java.FieldAccess`, `Java.FieldAccessExpression`, `Java.LocalVariableAccess`, `Java.ParenthesizedExpression`, `Java.SuperclassFieldAccessExpression`

Enclosing class:
  `Java`

public abstract static class Java.Lvalue extends Java.Rvalue
Representation of an "lvalue", i.e. an expression that has a type and a value, and can be assigned to: An expression that can be the left-hand-side of an assignment.

## Field Summary

### Fields inherited from class org.codehaus.janino.Java.Located

`NOWHERE`

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`Lvalue(Location location)`

## Method Summary

Modifier and Type
Method
Description
`abstract <R, EX extends Throwable>
R`
`accept(Visitor.LvalueVisitor<R,EX> lvv)`
Invokes the "`visit...()`" method of `Visitor.LvalueVisitor` for the concrete `Java.Lvalue` type.
`final <R, EX extends Throwable>
R`
`accept(Visitor.RvalueVisitor<R,EX> visitor)`
Invokes the "`visit...()`" method of `Visitor.RvalueVisitor` for the concrete `Java.Rvalue` type.
`Java.Lvalue`
`toLvalue()`

### Methods inherited from class org.codehaus.janino.Java.Rvalue

`accept, accept, accept, getEnclosingScope, getEnclosingScopeOrNull, setEnclosingScope, toRvalue`

### Methods inherited from class org.codehaus.janino.Java.Atom

`toLvalueOrCompileException, toRvalueOrCompileException, toString, toType, toTypeOrCompileException`

### Methods inherited from class org.codehaus.janino.Java.Located

`getLocation, throwCompileException`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.codehaus.janino.Java.Locatable

`getLocation, throwCompileException`

## Constructor Details

### Lvalue

protected Lvalue(Location location)

## Method Details

### toLvalue

@Nullable public Java.Lvalue toLvalue()

Overrides:
  `toLvalue` in class `Java.Atom`
Returns:
  This atom, converted to `Java.Lvalue`, or `null` if this atom is not an lvalue

### accept

@Nullable public abstract <R, EX extends Throwable> R accept(Visitor.LvalueVisitor<R,EX> lvv) throws EX
Invokes the "`visit...()`" method of `Visitor.LvalueVisitor` for the concrete `Java.Lvalue` type.

Throws:
  `EX`

### accept

@Nullable public final <R, EX extends Throwable> R accept(Visitor.RvalueVisitor<R,EX> visitor) throws EX
Description copied from class: `Java.Rvalue`
Invokes the "`visit...()`" method of `Visitor.RvalueVisitor` for the concrete `Java.Rvalue` type.

Specified by:
  `accept` in class `Java.Rvalue`
Throws:
  `EX`